Attribute VB_Name = "Module1"
Option Explicit
Global Const KEY_DOWN As Integer = &H1000
Global Const SND_ASYNC = &H1, SND_NOSTOP = &H10
Global Const SCREEN_WIDTH = 640
Global Const SCREEN_HEIGHT = 480
Global Const MAP_WIDTH = 800
Global Const MAP_HEIGHT = 600
Global Const TILESIZE = 32
Global Const COL_VISIBLE = SCREEN_WIDTH / TILESIZE
Global Const ROW_VISIBLE = SCREEN_HEIGHT / TILESIZE
Global Const MAXCOL = MAP_WIDTH / TILESIZE
Global Const MAXROW = MAP_HEIGHT / TILESIZE
Global Const TOTAL_MAP = 13

Global Const LISNA = 0
Global Const ANGELIA = 1
Global Const RIO = 2
Global Const ARTIN = 3

Global Const EXIT_MAP = 5
Global Const EVENTS = 50

Global Const WORLD_MAP = 0
Global Const LISNA_HOUSE = 1
Global Const BOTANICAL = 2
Global Const SNOW_AREA_MAP = 3
Global Const SNOW_HOUSE_MAP = 4
Global Const SCHOOL_MAP = 5
Global Const LIBRARY_MAP = 6
Global Const SPACE_MAP = 7
Global Const TOWER_MAP1 = 8
Global Const TOWER_MAP2 = 9
Global Const TOWER_MAP3 = 10
Global Const DESERT_TOWN = 11
Global Const LOTUS_MAP = 12

' *** music code
Global Const WORLD_MS As Byte = 0
Global Const PEACE_MS As Byte = 1
Global Const CASTLE_MS As Byte = 2
Global Const SCHOOL_MS As Byte = 3
Global Const WAR1_MS As Byte = 4
Global Const WAR2_MS As Byte = 5
Global Const WAR3_MS As Byte = 6
Global Const WAR4_MS As Byte = 7
Global Const BOTANICAL_MS As Byte = 8
Global Const TOWER_MS As Byte = 9
Global Const LOTUS_MS As Byte = 10
Global Const LECTURE_MS As Byte = 11
Global Const END_MS As Byte = 12
Global Const OPEN_MS As Byte = 13
Global Const WORLD2_MS As Byte = 14

' *** Sound Code
Global Const PUNCH_SND = 0
Global Const DEATH1_SND = 1
Global Const DEATH2_SND = 2
Global Const CURE_SND = 3
Global Const POWERUP_SND = 4
Global Const BLACK_SND = 5
Global Const PHOENIX_SND = 6
Global Const RUDRA_SND = 7
Global Const ICEFORMATION_SND = 8
Global Const ICEBREAK_SND = 9
Global Const ICEDROP_SND = 10
Global Const THUNDER_SND = 11
Global Const FSWORD_SND = 12
Global Const SWORD_SND = 13
Global Const HFIRE_SND = 14
Global Const SHURA_SND = 15
Global Const TORNADO_SND = 16
Global Const SALAMANDER_SND = 17
Global Const GEYSER_SND = 18
Global Const FLOOD_SND = 19
Global Const ARMAGEDDON_SND = 20
Global Const LBOLT_SND = 21
Global Const SCREAM_SND = 22

' Battle Situation
Global Const GENERAL = 0
Global Const BOSS_BOTANICAL = 1
Global Const BOSS_TOWER1 = 2
Global Const BOSS_TOWER2 = 3
Global Const BOSS_TOWER3 = 4
Global Const BOSS_LOTUS = 5
Global Const BOSS_LECTURE = 6

' ** item constant
Global Const HERB = 0
Global Const REVIVE = 1
Global Const ELIXIR = 2
Global Const POTION = 3
Global Const ETHER = 4
Global Const MIRACLE = 5

Type technique_properties
   name As String
   cost As Integer
End Type

Type item_properties
   name As String
   number As String
End Type

Type player_properties
 name As String
 HP As Integer
 MAXHP As Integer
 MP As Integer
 MAXMP As Integer
 x As Integer
 y As Integer
 offense As Integer
 defense As Integer
 level As Integer
 experience As Single
 TIME As Integer
 speed As Integer
 tech As Integer
 technique(4) As technique_properties
End Type
 
Type actor_properties
 x As Integer
 y As Integer
 offset As Integer
 Frame As Integer
 direction As Integer
End Type
 
Type sub_map_properties
 value As Integer
 special As Integer
End Type
 
Type map_properties
 grid(MAXCOL - 1, MAXROW - 1) As sub_map_properties
End Type

' ** DirectX !!!
Global dx As New DirectX7
' *** DirectSound
Global Ds As DirectSound
Global DsBuffer As DirectSoundBuffer
Global DsDesc As DSBUFFERDESC
Global DsWave As WAVEFORMATEX
' **** DirectMusic
Global perf As DirectMusicPerformance
Global seg As DirectMusicSegment
Global segstate As DirectMusicSegmentState
Global loader As DirectMusicLoader

Global old_width As Long, old_height As Long
Global p233class As Boolean
Global musiccode As Byte
Global item(5) As item_properties
Global open_status As Boolean
Global gold As Integer
Global limitexp(11)
Global Battle_situation
Global player_num As Integer
Global player(3) As player_properties
Global actor As actor_properties
Global map(TOTAL_MAP - 1) As map_properties
Global startCOL As Integer, startROW As Integer
Global Current_Map As Integer
Global Xmap As Integer, Ymap As Integer
Global lname As String, current_actor As Integer

' Event Trigger
Global ANGEL_ARRIVE As Boolean
Global BOTANICAL_EVENT As Boolean
Global BOTANICAL_EVENT2 As Boolean
Global ARTIN_EVENT As Boolean
Global TOWER1_EVENT As Boolean
Global TOWER2_EVENT As Boolean
Global TOWER3_EVENT As Boolean
Global DESERT_EVENT As Boolean
Global LOTUS_EVENT1 As Boolean
Global LOTUS_EVENT2 As Boolean
Global LIBRARY_EVENT As Boolean
Global L_EVENT As Boolean

Declare Function EnumDisplaySettings Lib "user32" Alias "EnumDisplaySettingsA" (ByVal lpszDeviceName As Long, ByVal iModeNum As Long, lpDevMode As Any) As Boolean

Declare Function ChangeDisplaySettings Lib "user32" Alias "ChangeDisplaySettingsA" (lpDevMode As Any, ByVal dwFlags As Long) As Long

Declare Function GetTickCount Lib "kernel32" () As Long

Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer

'*** BitBlock Transfer
Declare Function BitBlt Lib "gdi32" _
                (ByVal hDestDC As Long, _
                 ByVal x As Long, _
                 ByVal y As Long, _
                 ByVal nWidth As Long, _
                 ByVal nHeight As Long, _
                 ByVal hSrcDC As Long, _
                 ByVal xsrc As Long, _
                 ByVal ySrc As Long, _
                 ByVal dwRop As Long) As Long
                 
Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, _
ByVal x As Long, ByVal y As Long, _
ByVal nWidth As Long, ByVal nHeight As Long, _
ByVal hSrcDC As Long, ByVal xsrc As Long, _
ByVal ySrc As Long, ByVal nSrcWidth As Long, _
ByVal nSrcHeight As Long, ByVal dwRop As Long _
) As Long
                 
Sub delay(wait As Long)
Dim lasttick As Long
Dim currenttick As Long
  
If p233class = False And wait < 30 And wait > 9 Then wait = wait + 20
  
  lasttick = GetTickCount
  
  Do
  currenttick = GetTickCount
  DoEvents
  Loop Until ((currenttick - lasttick) > wait)
  
End Sub
Sub init_sound()
Set Ds = dx.DirectSoundCreate("")

DsDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME Or DSBCAPS_STATIC
DsWave.nFormatTag = WAVE_FORMAT_PCM
DsWave.nChannels = 2
DsWave.lSamplesPerSec = 22050
DsWave.nBitsPerSample = 16
DsWave.nBlockAlign = DsWave.nBitsPerSample / 8 * DsWave.nChannels
DsWave.lAvgBytesPerSec = DsWave.lSamplesPerSec * DsWave.nBlockAlign

End Sub
Sub init_music()

Set loader = dx.DirectMusicLoaderCreate()

Set perf = dx.DirectMusicPerformanceCreate()

Call perf.Init(Nothing, 0)

' ** Standard port
perf.SetPort -1, 80
Call perf.SetMasterAutoDownload(True)
' ** The volume 0-100%, we have 75% to understand the formula
perf.SetMasterVolume (75 * 42 - 3000)

End Sub
Sub determine_music(request As Byte)

If musiccode = request Then Exit Sub

musiccode = request

Call Backgroundmusic(musiccode)

End Sub
Sub sound(i As Integer)
Dim filename As String

Select Case i
 Case PUNCH_SND
  filename = App.Path & "\se\punch.wav"
 Case DEATH1_SND
  filename = App.Path & "\se\death.wav"
 Case DEATH2_SND
  filename = App.Path & "\se\death2.wav"
 Case CURE_SND
  filename = App.Path & "\se\cure.wav"
 Case POWERUP_SND
  filename = App.Path & "\se\powerup.wav"
 Case BLACK_SND
  filename = App.Path & "\se\blackhole.wav"
 Case PHOENIX_SND
  filename = App.Path & "\se\phoenix.wav"
 Case RUDRA_SND
  filename = App.Path & "\se\rudra.wav"
 Case ICEFORMATION_SND
  filename = App.Path & "\se\iceformation.wav"
 Case ICEBREAK_SND
  filename = App.Path & "\se\icebreak.wav"
 Case ICEDROP_SND
  filename = App.Path & "\se\icedrop.wav"
 Case THUNDER_SND
  filename = App.Path & "\se\thunder.wav"
 Case FSWORD_SND
  filename = App.Path & "\se\fsword.wav"
 Case SWORD_SND
  filename = App.Path & "\se\sword.wav"
 Case HFIRE_SND
  filename = App.Path & "\se\hfire.wav"
 Case SHURA_SND
  filename = App.Path & "\se\shura.wav"
 Case TORNADO_SND
  filename = App.Path & "\se\tornado.wav"
 Case SALAMANDER_SND
  filename = App.Path & "\se\salamander.wav"
 Case GEYSER_SND
  filename = App.Path & "\se\geyser.wav"
 Case FLOOD_SND
  filename = App.Path & "\se\flood.wav"
 Case ARMAGEDDON_SND
  filename = App.Path & "\se\armageddon.wav"
 Case LBOLT_SND
  filename = App.Path & "\se\lbolt.wav"
 Case SCREAM_SND
  filename = App.Path & "\se\scream.wav"
End Select

Set DsBuffer = Ds.CreateSoundBufferFromFile(filename, DsDesc, DsWave)

DsBuffer.Play DSBPLAY_DEFAULT

End Sub
Sub ServiceBackgroundMusic()

If perf.IsPlaying(seg, segstate) = False Then
   Set segstate = perf.PlaySegment(seg, 0, 0)
End If

End Sub
Sub Backgroundmusic(i As Byte)

Dim filename As String

If i = WORLD_MS Then
   If L_EVENT = True Then i = WORLD2_MS
End If

Select Case i
 Case WORLD_MS
  filename = App.Path & "\Music\world.mid"
  
 Case PEACE_MS
  filename = App.Path & "\Music\Peace.mid"

 Case CASTLE_MS
  filename = App.Path & "\Music\Castle.mid"
 
 Case SCHOOL_MS
  filename = App.Path & "\Music\School.mid"
 
 Case WAR1_MS
  filename = App.Path & "\Music\war1.mid"
 
 Case WAR2_MS
  filename = App.Path & "\Music\war2.mid"
 
 Case WAR3_MS
  filename = App.Path & "\Music\war3.mid"
 
 Case WAR4_MS
  filename = App.Path & "\Music\war4.mid"
 
 Case BOTANICAL_MS
  filename = App.Path & "\Music\botanywar.mid"
 
 Case TOWER_MS
  filename = App.Path & "\Music\towerwar.mid"
  
 Case LOTUS_MS
  filename = App.Path & "\Music\lotuswar.mid"
  
 Case LECTURE_MS
  filename = App.Path & "\Music\lecturewar.mid"
  
 Case END_MS
  filename = App.Path & "\Music\end.mid"
  
 Case OPEN_MS
  filename = App.Path & "\Music\open.mid"
 
 Case WORLD2_MS
  filename = App.Path & "\Music\world2.mid"
End Select

' ** Load the MIDI and set it to Segment
Set seg = loader.LoadSegment(filename)
seg.SetStandardMidiFile

Set segstate = perf.PlaySegment(seg, 0, 0)

End Sub

Sub player_first_status()

With player(LISNA)
     .name = "Lisna"
     .defense = 10
     .experience = 0
     .MAXHP = 100
     .level = 1
     .MAXMP = 200
     .offense = 20
     .speed = 25
     .tech = 1
     .technique(0).name = "Black Hole 20"
     .technique(0).cost = 20
     .technique(1).name = "Typhoon 40"
     .technique(1).cost = 40
     .technique(2).name = "Death Strike 60"
     .technique(2).cost = 60
     .technique(3).name = "Phoenix 100"
     .technique(3).cost = 100
     .technique(4).name = "Shura 120"
     .technique(4).cost = 120
End With

With player(ANGELIA)
     .name = "Angelia"
     .defense = 10
     .experience = 0
     .MAXHP = 100
     .level = 1
     .MAXMP = 200
     .offense = 15
     .speed = 25
     .tech = 1
     .technique(0).name = "Cure Single 30"
     .technique(0).cost = 30
     .technique(1).name = "Ice Fang 40"
     .technique(1).cost = 40
     .technique(2).name = "Frozen Mt. 80"
     .technique(2).cost = 80
     .technique(3).name = "Cure All 300"
     .technique(3).cost = 300
     .technique(4).name = "Glacier 120"
     .technique(4).cost = 120
End With

With player(RIO)
     .name = "Rio"
     .defense = 30
     .experience = 0
     .MAXHP = 250
     .level = 1
     .MAXMP = 100
     .offense = 30
     .speed = 25
     .tech = 1
     .technique(0).name = "Fire Sword 20"
     .technique(0).cost = 20
     .technique(1).name = "Hell Fire 30"
     .technique(1).cost = 30
     .technique(2).name = "Dragon Flare 80"
     .technique(2).cost = 80
     .technique(3).name = "Armageddon 100"
     .technique(3).cost = 100
     .technique(4).name = "Rudra Dragon 150"
     .technique(4).cost = 150
End With

With player(ARTIN)
     .name = "Artin"
     .defense = 35
     .experience = 0
     .MAXHP = 300
     .level = 1
     .MAXMP = 100
     .offense = 25
     .speed = 25
     .tech = 1
     .technique(0).name = "Cure Single 20"
     .technique(0).cost = 20
     .technique(1).name = "Lighting Bolt 20"
     .technique(1).cost = 20
     .technique(2).name = "Geyser 40"
     .technique(2).cost = 40
     .technique(3).name = "Flood 80"
     .technique(3).cost = 80
     .technique(4).name = "Thunder 100"
     .technique(4).cost = 100
End With

End Sub

Sub levelup(i As Integer)

With player(i)
 Select Case i
  Case LISNA
   .level = .level + 1
   .MAXHP = .MAXHP + 100
   .MAXMP = .MAXMP + 150
   .offense = .offense + 12 + Int(Rnd * 3)
   .defense = .defense + 5 + Int(Rnd * 3)
   .speed = .speed + 3 + Int(Rnd * 3)
   If .tech < 5 Then .tech = .tech + 1
  
  Case ANGELIA
   .level = .level + 1
   .MAXHP = .MAXHP + 90
   .MAXMP = .MAXMP + 160
   .offense = .offense + 9 + Int(Rnd * 3)
   .defense = .defense + 5 + Int(Rnd * 3)
   .speed = .speed + 3 + Int(Rnd * 3)
   If .tech < 5 Then .tech = .tech + 1
   
  Case RIO
   .level = .level + 1
   .MAXHP = .MAXHP + 150
   .MAXMP = .MAXMP + 100
   .offense = .offense + 18 + Int(Rnd * 3)
   .defense = .defense + 5 + Int(Rnd * 3)
   .speed = .speed + 3 + Int(Rnd * 3)
   If .tech < 5 Then .tech = .tech + 1
   
  Case ARTIN
   .level = .level + 1
   .MAXHP = .MAXHP + 130
   .MAXMP = .MAXMP + 120
   .offense = .offense + 15 + Int(Rnd * 3)
   .defense = .defense + 6 + Int(Rnd * 3)
   .speed = .speed + 3 + Int(Rnd * 3)
   If .tech < 5 Then .tech = .tech + 1
 
 End Select
End With

End Sub
Sub full_hp()
Dim i As Integer

For i = 0 To 3
 player(i).HP = player(i).MAXHP
Next i

End Sub
Sub full_mp()
Dim i As Integer

For i = 0 To 3
 player(i).MP = player(i).MAXMP
Next i

End Sub

Sub item_use(i As Integer, target As Integer)

Select Case i
 Case HERB
  If player(target).HP > 0 Then player(target).HP = player(target).HP + 100
  If player(target).HP > player(target).MAXHP Then player(target).HP = player(target).MAXHP
 Case REVIVE
  If player(target).HP <= 0 Then player(target).HP = player(target).HP + 200
 Case ELIXIR
  player(target).MP = player(target).MP + 100
  If player(target).MP > player(target).MAXMP Then player(target).MP = player(target).MAXMP
 Case POTION
  If player(target).HP > 0 Then player(target).HP = player(target).HP + 500
  If player(target).HP > player(target).MAXHP Then player(target).HP = player(target).MAXHP
 Case ETHER
  player(target).MP = player(target).MP + 500
  If player(target).MP > player(target).MAXMP Then player(target).MP = player(target).MAXMP
 Case MIRACLE
  player(target).HP = player(target).MAXHP
  player(target).MP = player(target).MAXMP
End Select

End Sub
Sub StopBGM()

Call perf.Stop(seg, segstate, 0, 0)

End Sub
Sub stop_DIRECTX()

'*** DirectMusic
Call perf.Stop(seg, segstate, 0, 0)
If Not (perf Is Nothing) Then perf.CloseDown

End Sub
